import java.util.*;
import java.io.*;

public class gonarch_stresser {
	FastScanner in;
	PrintWriter out;

	final int maxValue = 100 * 1000;
	final static Random rng = new Random();
	
	
	public void solve(int arg) throws IOException {
		int countQueries = 11000;
		out.println(countQueries);
		int countQuestions = 0;
		for (int i = 0; i < countQueries; i++) {
			if (i % arg == 0) {
				out.println("+ " + (rng.nextInt(maxValue) + 1));
			} else {
				out.println("? " + (rng.nextInt(maxValue) + 1));
				countQuestions++;
			}
		}
		out.close();
		gonarch_akov_N2.main(new String[0]);
		in = new FastScanner(new File("gonarch.out"));
		int[] answer = new int[countQuestions];
		for (int i = 0; i < countQuestions; i++) {
			answer[i] = in.nextInt();
		}
		gonarch_akov_TsqrtNlogN.main(new String[0]);
		in = new FastScanner(new File("gonarch.out"));
		for (int i = 0; i < countQuestions; i++) {
			int k = in.nextInt();
			if (k != answer[i]) {
				System.err.println("expected " + answer[i] + " found " + k);
				System.err.println("FAIL" + i);
			}
		}
	}

	public void run() {
		try {
			for (int i = 0; i < 300; i++) {
				out = new PrintWriter(new File("gonarch.in"));
				int arg = rng.nextInt(20) + 1;
				solve(arg);
				System.err.println(i + " " + arg);
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

	}

	public static void main(String[] arg) {
		new gonarch_stresser().run();
	}
}